artao

所有不同的序列串-----LCS算法的变种

今天遇到LEETCODE的第115题: Distinct Subsequences

Given a string S and a string T, count the number of distinct subsequences of S which equals T.

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, "ACE" is a subsequence of "ABCDE" while "AEC" is not).

Example 1:

Input: S = "rabbbit", T = "rabbit"
Output: 3
Explanation:

As shown below, there are 3 ways you can generate "rabbit" from S.
(The caret symbol ^ means the chosen letters)

rabbbit
^^^^ ^^
rabbbit
^^ ^^^^
rabbbit
^^^ ^^^

Example 2:

Input: S = "babgbag", T = "bag"
Output: 5
Explanation:

As shown below, there are 5 ways you can generate "bag" from S.
(The caret symbol ^ means the chosen letters)

babgbag
^^ ^
babgbag
^^    ^
babgbag
^    ^^
babgbag
  ^  ^^
babgbag
    ^^^

解法1:动态规划
假设已经得到了s[:i]中所有的t串f(i,t),考虑s[i]和t[-1]这2个字符,if不等:f(i+1,t)=f(i,t);else:f(i+1,t)=f(i,t)+f(i+1,t[:-1])。于是解法如下:
def dp(s,t):
  if len(s)<len(t):return 0
  if len(t)==1:return s.count(t)
  ans=dp(s[:-1],t)
  if s[-1]==t[-1]:ans+=dp(s[:-1],t[:-1])
return ans
测试中发现对比较长的S,出现了超时错误,说明时间复杂度高(O(len(s)*len(t)))。

解法2:二分法
对S进行等长分割成left,right,则结果应该=left中的数量 + right中的数量 + 跨界的数量
其中,跨界的数量 = left中的t[:1]数量*right中的t[1:]数量 + left中的t[:2]数量*right中的t[2:]数量 +...+ left中的t[:-1]数量*right中的t[-1]数量
于是解法如下:
def dp(s,t):
            print(s,t)
            if len(s)<len(t):return 0
            if len(t)==1:return s.count(t)
            n=len(s)//2
            left,right=s[:n],s[n+1:]
            ans=dp(left,t)+dp(right,t)
            for i in range(1,len(t)):
                ans+=dp(left,t[:i])*dp(right,t[i:])
            return ans
测试中发现对比较长的S,出现了超时错误,说明时间复杂度高(O(len(s)*len(t)))。同时也说明跨界的数量不能直接算出的话,最好不要用二分法。

解法3:动态规划
再回到解法1,这次用二维转移矩阵,令f(i,j)=s[:i]中t[:j]的数量,考虑s[i]和t[j]这2个字符,if不等:f(i+1,j+1)=f(i,j);else:f(i+1,j+1)=f(i,j)+f(i+1,j)。于是解法如下:
def dp(s,t):

res = [[0] * (len(s) + 1) for _ in range(len(t) + 1)] res[0] = [1] * (len(s) + 1) for i, cht in enumerate(t): for j, chs in enumerate(s): if cht == chs: res[i + 1][j + 1] = res[i][j] + res[i + 1][j] else: res[i + 1][j + 1] = res[i + 1][j] return res[-1][-1]
进一步优化为:

def dp(s,t):
   li=[0]*len(t)
   d={}
   for i in range(len(t)):
      d[t[i]]=d.get(t[i],[])+[i]
   for i in range(len(s)):
      print(i,li,end=' ')
      if s[i] in t:
         for j in reversed(d[s[i]]):
            if j == 0:
               li[0] += 1
            else:
               li[j] += li[j - 1]
      print(li)
   return li[-1]

posted on 2018-08-21 14:18  artao  阅读(251)  评论(0编辑  收藏  举报

导航